searchNodes=[{"doc":"This module allows you to use Rational numbers in Elixir, to enable exact calculations with all numbers big and small. Ratio defines arithmetic and comparison operations to work with rational numbers. This module also contains: a guard-safe is_rational/1 check. a compare/2 function for use with e.g. Enum.sort . to_float/1 to (lossly) convert a rational into a float. Shorthand infix construction operator Since version 4.0, Ratio no longer defines an infix operator to create rational numbers. Instead, rational numbers are made using Ratio.new , and as the output from using an existing Ratio struct with a mathematical operation. If you do want to use an infix operator such as &lt;~&gt; (supported in all Elixir versions) or &lt;|&gt; (deprecated in Elixir v1.14, the default of older versions of the Ratio library) you can add the following one-liner to the module(s) in which you want to use it: defdelegate numerator &lt;~&gt; denominator , to : Ratio , as : :new Inline Math Operators and Casting Ratio interopts with the Numbers library: If you want to overload Elixir's builtin math operators, you can use use Numbers, overload_operators: true . This also allows you to pass in a rational number as one argument and an integer, float or Decimal (if you have installed the Decimal library), which are then cast to rational numbers whenever necessary. defmodule IDoAlotOfMathHere do defdelegate numerator &lt;~&gt; denominator , to : Ratio , as : :new use Numbers , overload_operators : true def calculate ( input ) do num = input &lt;~&gt; 2 result = num * 2 + ( 3 &lt;~&gt; 4 ) * 5.0 result / 2 end end iex&gt; IDoAlotOfMathHere . calculate ( 42 ) Ratio . new ( 183 , 8 )","ref":"Ratio.html","title":"Ratio","type":"module"},{"doc":"A Rational number is defined as a numerator and a denominator. Both the numerator and the denominator are integers. If you want to match for a rational number, you can do so by matching against this Struct. Note that directly manipulating the struct, however, is usually a bad idea, as then there are no validity checks, nor wil the rational be simplified. Use Ratio.new/2 instead.","ref":"Ratio.html#__struct__/0","title":"Ratio.__struct__/0","type":"function"},{"doc":"Returns the absolute version of the given number (which might be an integer, float or Rational). Examples iex&gt; Ratio . abs ( Ratio . new ( - 5 , 2 ) ) Ratio . new ( 5 , 2 )","ref":"Ratio.html#abs/1","title":"Ratio.abs/1","type":"function"},{"doc":"Adds two rational numbers.","ref":"Ratio.html#add/2","title":"Ratio.add/2","type":"function"},{"doc":"Rounds a number (rational, integer or float) to the largest whole number larger than or equal to num. For negative numbers, this means we are rounding towards negative infinity. iex&gt; Ratio.ceil(Ratio.new(1, 2)) 1 iex&gt; Ratio.ceil(Ratio.new(5, 4)) 2 iex&gt; Ratio.ceil(Ratio.new(-3, 2)) -1 iex&gt; Ratio.ceil(Ratio.new(400)) 400","ref":"Ratio.html#ceil/1","title":"Ratio.ceil/1","type":"function"},{"doc":"Compares two rational numbers, returning :lt , :eg or :gt depending on whether a is less than, equal to or greater than b , respectively. This function is able to compare rational numbers against integers or floats as well. This function accepts other types as input as well, comparing them using Erlang's Term Ordering. This is mostly useful if you have a collection that contains other kinds of numbers (builtin integers or floats) as well.","ref":"Ratio.html#compare/2","title":"Ratio.compare/2","type":"function"},{"doc":"Treats the passed number as a Rational number, and extracts its denominator. For integers, returns 1 .","ref":"Ratio.html#denominator/1","title":"Ratio.denominator/1","type":"function"},{"doc":"Divides the rational number a by the rational number b . Examples iex&gt; Ratio.div(Ratio.new(2, 3), Ratio.new(8, 5)) Ratio.new(5, 12)","ref":"Ratio.html#div/2","title":"Ratio.div/2","type":"function"},{"doc":"True if a is equal to b","ref":"Ratio.html#eq?/2","title":"Ratio.eq?/2","type":"function"},{"doc":"True if a is equal to b ?","ref":"Ratio.html#equal?/2","title":"Ratio.equal?/2","type":"function"},{"doc":"Rounds a number (rational, integer or float) to the largest whole number less than or equal to num. For negative numbers, this means we are rounding towards negative infinity. iex&gt; Ratio.floor(Ratio.new(1, 2)) 0 iex&gt; Ratio.floor(Ratio.new(5, 4)) 1 iex&gt; Ratio.floor(Ratio.new(-3, 2)) -2","ref":"Ratio.html#floor/1","title":"Ratio.floor/1","type":"function"},{"doc":"True if a is larger than or equal to b","ref":"Ratio.html#gt?/2","title":"Ratio.gt?/2","type":"function"},{"doc":"True if a is larger than or equal to b","ref":"Ratio.html#gte?/2","title":"Ratio.gte?/2","type":"function"},{"doc":"Check to see whether something is a ratioal struct. On recent OTP versions that expose :erlang.map_get/2 this function is guard safe. iex&gt; require Ratio iex&gt; Ratio.is_rational(Ratio.new(1, 2)) true iex&gt; Ratio.is_rational(Ratio.new(10)) true iex&gt; Ratio.is_rational(42) false iex&gt; Ratio.is_rational(%{}) false iex&gt; Ratio.is_rational(&quot;My quick brown fox&quot;) false","ref":"Ratio.html#is_rational/1","title":"Ratio.is_rational/1","type":"macro"},{"doc":"True if a is smaller than b","ref":"Ratio.html#lt?/2","title":"Ratio.lt?/2","type":"function"},{"doc":"True if a is smaller than or equal to b","ref":"Ratio.html#lte?/2","title":"Ratio.lte?/2","type":"function"},{"doc":"Negates the given rational number. Examples iex&gt; Ratio.minus(Ratio.new(5, 3)) Ratio.new(-5, 3)","ref":"Ratio.html#minus/1","title":"Ratio.minus/1","type":"function"},{"doc":"Multiplies two rational numbers. Examples iex&gt; Ratio.mult( Ratio.new(1, 3), Ratio.new(1, 2)) Ratio.new(1, 6)","ref":"Ratio.html#mult/2","title":"Ratio.mult/2","type":"function"},{"doc":"Creates a new Rational number. This number is simplified to the most basic form automatically. Rational numbers with a 0 as denominator are not allowed. Note that it is recommended to use integer numbers for the numerator and the denominator. Floats If possible, don't use them. Using Floats for the numerator or denominator is possible, however, because base-2 floats cannot represent all base-10 fractions properly, the results might be different from what you might expect. See The Perils of Floating Point for more information about this. Floats are converted into rationals by using Float.ratio (since version 3.0). Decimals To use Decimal parameters, the decimal library must be configured in mix.exs . Examples iex&gt; Ratio . new ( 1 , 2 ) Ratio . new ( 1 , 2 ) iex&gt; Ratio . new ( 100 , 300 ) Ratio . new ( 1 , 3 ) iex&gt; Ratio . new ( 1.5 , 4 ) Ratio . new ( 3 , 8 ) iex&gt; Ratio . new ( Ratio . new ( 3 , 2 ) , 3 ) Ratio . new ( 1 , 2 ) iex&gt; Ratio . new ( Ratio . new ( 3 , 3 ) , 2 ) Ratio . new ( 1 , 2 ) iex&gt; Ratio . new ( Ratio . new ( 3 , 2 ) , Ratio . new ( 1 , 3 ) ) Ratio . new ( 9 , 2 )","ref":"Ratio.html#new/2","title":"Ratio.new/2","type":"function"},{"doc":"Converts the passed number as a Rational number, and extracts its denominator. For integers returns the passed number itself.","ref":"Ratio.html#numerator/1","title":"Ratio.numerator/1","type":"function"},{"doc":"returns x to the n th power. x is allowed to be an integer, rational or float (in the last case, this is first converted to a rational). Will give the answer as a rational number when applicable. Note that the exponent n is only allowed to be an integer. (so it is not possible to compute roots using this function.) Examples iex&gt; Ratio . pow ( Ratio . new ( 2 ) , 4 ) Ratio . new ( 16 , 1 ) iex&gt; Ratio . pow ( Ratio . new ( 2 ) , - 4 ) Ratio . new ( 1 , 16 ) iex&gt; Ratio . pow ( Ratio . new ( 3 , 2 ) , 10 ) Ratio . new ( 59049 , 1024 ) iex&gt; Ratio . pow ( Ratio . new ( 10 ) , 0 ) Ratio . new ( 1 , 1 )","ref":"Ratio.html#pow/2","title":"Ratio.pow/2","type":"function"},{"doc":"Returns the sign of the given number (which might be an integer, float or Rational) This is: 1 if the number is positive. -1 if the number is negative. 0 if the number is zero.","ref":"Ratio.html#sign/1","title":"Ratio.sign/1","type":"function"},{"doc":"Subtracts the rational number b from the rational number a .","ref":"Ratio.html#sub/2","title":"Ratio.sub/2","type":"function"},{"doc":"Converts the given number to a Float. As floats do not have arbitrary precision, this operation is generally not reversible.","ref":"Ratio.html#to_float/1","title":"Ratio.to_float/1","type":"function"},{"doc":"Returns a tuple, where the first element is the result of to_float(number) and the second is a conversion error. The conversion error is calculated by subtracting the original number from the conversion result. Examples iex&gt; Ratio . to_float_error ( Ratio . new ( 1 , 2 ) ) { 0.5 , Ratio . new ( 0 , 1 ) } iex&gt; Ratio . to_float_error ( Ratio . new ( 2 , 3 ) ) { 0.6666666666666666 , Ratio . new ( - 1 , 27021597764222976 ) }","ref":"Ratio.html#to_float_error/1","title":"Ratio.to_float_error/1","type":"function"},{"doc":"Returns a binstring representation of the Rational number. If the denominator is 1 it will still be printed wrapped with Ratio.new . Examples iex&gt; Ratio . to_string Ratio . new ( 10 , 7 ) &quot;Ratio.new(10, 7)&quot; iex&gt; Ratio . to_string Ratio . new ( 10 , 2 ) &quot;Ratio.new(5, 1)&quot;","ref":"Ratio.html#to_string/1","title":"Ratio.to_string/1","type":"function"},{"doc":"Returns the integer part of number. Examples iex&gt; Ratio . trunc ( 1.7 ) 1 iex&gt; Ratio . trunc ( - 1.7 ) - 1 iex&gt; Ratio . trunc ( 3 ) 3 iex&gt; Ratio . trunc ( Ratio . new ( 5 , 2 ) ) 2","ref":"Ratio.html#trunc/1","title":"Ratio.trunc/1","type":"function"},{"doc":"","ref":"Ratio.html#t:t/0","title":"Ratio.t/0","type":"type"},{"doc":"","ref":"Ratio.DecimalConversion.html","title":"Ratio.DecimalConversion","type":"module"},{"doc":"","ref":"Ratio.DecimalConversion.html#decimal_to_rational/1","title":"Ratio.DecimalConversion.decimal_to_rational/1","type":"function"},{"doc":"","ref":"Ratio.FloatConversion.html","title":"Ratio.FloatConversion","type":"module"},{"doc":"Converts a float to a rational number. Because base-2 floats cannot represent all base-10 fractions properly, the results might be different from what you might expect. See The Perils of Floating Point for more information about this. Examples iex&gt; Ratio.FloatConversion . float_to_rational ( 10.0 ) Ratio . new ( 10 , 1 ) iex&gt; Ratio.FloatConversion . float_to_rational ( 13.5 ) Ratio . new ( 27 , 2 ) iex&gt; Ratio.FloatConversion . float_to_rational ( 1.1 ) Ratio . new ( 2476979795053773 , 2251799813685248 )","ref":"Ratio.FloatConversion.html#float_to_rational/1","title":"Ratio.FloatConversion.float_to_rational/1","type":"function"},{"doc":"","ref":"Ratio.ComparisonError.html","title":"Ratio.ComparisonError","type":"exception"},{"doc":"This library allows you to use Rational numbers in Elixir, to enable exact calculations with all numbers big and small. Ratio follows the Numeric behaviour from Numbers , and can therefore be used in combination with any data type that uses Numbers (such as Tensor and ComplexNum ).","ref":"readme.html","title":"Guide/Readme","type":"extras"},{"doc":"Ratio defines arithmetic and comparison operations to work with rational numbers. Rational numbers can be created by using Ratio.new/2 , or by calling mathematical operators where one of the two operands is already a rational number. Shorthand infix construction operator Since version 4.0, Ratio no longer defines an infix operator to create rational numbers. Instead, rational numbers are made using Ratio.new , and as the output from using an existing Ratio struct with a mathematical operation. If you do want to use an infix operator such as &lt;~&gt; (supported in all Elixir versions) or &lt;|&gt; (deprecated in Elixir v1.14, the default of older versions of the Ratio library) you can add the following one-liner to the module(s) in which you want to use it: defdelegate numerator &lt;~&gt; denominator , to : Ratio , as : :new Basic functionality Rational numbers can be manipulated using the functions in the Ratio module. iex&gt; Ratio . mult ( Ratio . new ( 1 , 3 ) , Ratio . new ( 1 , 2 ) ) Ratio . new ( 1 , 6 ) iex&gt; Ratio . div ( Ratio . new ( 2 , 3 ) , Ratio . new ( 8 , 5 ) ) Ratio . new ( 5 , 12 ) iex&gt; Ratio . pow ( Ratio . new ( 2 ) , 4 ) Ratio . new ( 16 , 1 ) The Ratio module also contains: a guard-safe is_rational/1 check. a compare/2 function for use with e.g. Enum.sort . to_float/1 to (lossly) convert a rational into a float. Inline Math Operators and Casting Ratio interopts with the Numbers library: If you want to overload Elixir's builtin math operators, you can add use Numbers, overload_operators: true to your module. This also allows you to pass in a rational number as one argument and an integer, float or Decimal (if you have installed the Decimal library), which are then cast to rational numbers whenever necessary: defmodule IDoAlotOfMathHere do defdelegate numerator &lt;~&gt; denominator , to : Ratio , as : :new use Numbers , overload_operators : true def calculate ( input ) do num = input &lt;~&gt; 2 result = num * 2 + ( 3 &lt;~&gt; 4 ) * 5.0 result / 2 end end iex&gt; IDoAlotOfMathHere . calculate ( 42 ) Ratio . new ( 183 , 8 )","ref":"readme.html#using-ratio","title":"Guide/Readme - Using Ratio","type":"extras"},{"doc":"The package can be installed from hex, by adding :ratio to your list of dependencies in mix.exs : def deps do [ { :ratio , &quot;~&gt; 4.0&quot; } ] end","ref":"readme.html#installation","title":"Guide/Readme - Installation","type":"extras"},{"doc":"4.0.0 - Remove infix operator &lt;|&gt; as its usage is deprecated in Elixir v1.14. This is a backwards-incompatible change. If you want to use the old syntax with the new version, add defdelegate num &lt;|&gt; denom, to: Ratio, as: :new to your module. Alternatively, you might want to use the not-deprecated &lt;~&gt; operator for this instead. Switch the Inspect implementation to use the form Ratio.new(10, 20) instead of 10 &lt;|&gt; 20 , related to above. This is also a backwards-incompatible change. Remove implementation of String.Chars , as the earlier implementation was not a (non-programmer) human-readable format. 3.0.2 - Fixes: A bug with &lt;|&gt; when the numerator was a rational and the denuminator an integer. (c.f. #104) Thank you, @varsill! 3.0.1 - Fixes: Problem where Ratio.ceil/1 would be off-by-one (c.f. #89). Thank you, @Hajto! Problem where Ratio.pow/2 would return an integer rather than a new Ratio.(c.f. #100). Thank you, @speeddragon! 3.0.0 - All operators except &lt;|&gt; are removed from Ratio. Instead, the operators defined by Numbers (which Ratio depends on) can be used, by adding use Numbers, overload_operators: true to your modules. (c.f. #34) All math-based functions expect and return Ratio structs (rather than also working on integers and returning integers sometimes if the output turned out to be a whole number). (c.f. #43) This makes the code more efficient and more clear for users. Ratio structs representing whole numbers are no longer implicitly converted 'back' to integers, as this behaviour was confusing. (c.f. #28) If conversion to/from other number-like types is really desired, use the automatic conversions provided by Ratio.new , &lt;|&gt; or (a bit slower but more general) the math functions exposed by Numbers . Ratio ships with implementations of Coerce.defcoercion for Integer -&gt; Ratio, Float -&gt; Ratio and Decimal -&gt; Ratio. is_rational?/1 is replaced with the guard-safe is_rational/1 (only exported on Erlang versions where :erlang.map_get/2 is available, i.e. &gt;= OTP 21.0.) (c.f. #37) Float.ratio/1 is now used to convert floats into Ratio structs, rather than maintaining a hand-written version of this logic. (c.f #46) Thank you, @marcinwasowicz ! A lot of property-based tests have been added to get some level of confidence of the correctness of the library's operations. 2.4.2 Uses extra_applications in mix.exs to silence warnings in Elixir 1.11 and onwards. 2.4.1 Fixes a bug in the decimal conversion implementation where certain decimals were not converted properly. Thank you, @iterateNZ! 2.4.0 Adds optional support for automatic conversion from Decimal s. Thank you, @kipcole ! 2.3.1 Removes spurious printing statement in Rational.FloatConversion that would output a line of text at compile-time. Fixes support for Numbers v5+ which was broken. 2.3.0 Adds trunc and to_floor_error functions. 2.1.1 Fixes implementation of floor and ceil which was counter-intuitive for negative numbers (it now correctly rounds towards negative infinity). Drops support for Elixir versions older than 1.4, because of use of Integer.floor_div . First version to support new Erlang versions (20 and onward) that have native floor and ceil functions. 2.1.0 Adds optional overloaded comparison operators. 2.0.0 Breaking change: Brought Ratio.compare/2 in line with Elixir's comparison function guideline, to return :lt | :eq | :gt . (This used to be -1 | 0 | 1 ). 1.2.9 Improved documentation. (Thanks, @morontt!) 1.2.8 Adding :numbers to the applications: list, to ensure that no warnings are thrown when building releases on Elixir &lt; 1.4.0. 1.2.6, 1.2.7 Improving documentation. 1.2.5 added ceil/1 and floor/1 . 1.2.4 Fixes Elixir 1.4 warnings in the mix.exs file. 1.2.3 Upgraded version of the Numbers dependency to 2.0. 1.2.2 Added default argument to Ratio.new/2 , to follow the Numeric behaviour fully, and added Ratio.minus/1 as alias for Ratio.negate/1 for the same reason. 1.2.0 Changed name of Ratio.mul/2 to Ratio.mult/2 , to avoid ambiguety, and to allow incorporation with Numbers . Deprecation Warning was added to using Ratio.mul/2 . 1.1.1 Negative floats are now converted correctly. 1.1.0 Elixir 1.3 compliance (Statefree if/else/catch clauses, etc.) 1.0.0 Proper __using__ macro, with more readable option names. Stable release. 0.6.0 First public release 0.0.1 First features","ref":"readme.html#changelog","title":"Guide/Readme - Changelog","type":"extras"},{"doc":"Observant readers might notice that there also is a ' rational ' library in Hex.pm. The design idea between that library vs. this one is a bit different: Ratio hides the internal data representation as much as possible, and numbers are therefore only created using Ratio.new/2 . This has as mayor advantage that the internal representation is always correct and simplified. The Ratio library also (optionally) overrides (by virtue of the Numbers library) the built-in math operations +, -, *, /, div, abs so they work with combinations of integers, floats and rationals. Finally, Ratio follows the Numeric behaviour, which means that it can be used with any data types that follow Numbers .","ref":"readme.html#difference-with-the-rational-library","title":"Guide/Readme - Difference with the 'rational' library","type":"extras"}]